Project Chrono: chrono::vehicle::m113::M113_Idler Class Reference

Public Member Functions | List of all members
chrono::vehicle::m113::M113_Idler Class Reference
Models » Vehicle models » M113 tracked vehicle

## Description

Idler and tensioner model for the M113 vehicle.

`#include <M113_Idler.h>`

Inheritance diagram for chrono::vehicle::m113::M113_Idler:
[legend]
Collaboration diagram for chrono::vehicle::m113::M113_Idler:
[legend]

## Public Member Functions
| M113_Idler (const std::string &name, VehicleSide side)
virtual const ChVector3d | GetLocation (PointId which) override
| Return the location of the specified hardpoint.
virtual double | GetCarrierMass () const override
| Return the mass of the carrier body.
virtual const ChVector3d & | GetCarrierInertia () override
| Return the moments of inertia of the carrier body.
virtual double | GetCarrierVisRadius () const override
| Return a visualization radius for the carrier body.
virtual double | GetPrismaticPitchAngle () const override
| Return the pitch angle of the prismatic joint.
virtual std::shared_ptr< ChLinkTSDA::ForceFunctor > | GetTensionerForceCallback () const override
| Return the functor object for spring force.
virtual double | GetTensionerFreeLength () const override
| Return the free length for the tensioner spring.
Public Member Functions inherited from chrono::vehicle::ChTranslationalIdler
| ChTranslationalIdler (const std::string &name)
virtual std::string | GetTemplateName () const override
| Get the name of the vehicle subsystem template.
virtual std::shared_ptr< ChBody > | GetCarrierBody () const override
| Return a handle to the carrier body to which the idler wheel is connected.
std::shared_ptr< ChLinkTSDA > | GetTensioner () const
| Get the tensioner force element.
virtual void | Initialize (std::shared_ptr< ChChassis > chassis, const ChVector3d &location, ChTrackAssembly *track) override
| Initialize this idler subsystem.
virtual void | AddVisualizationAssets (VisualizationType vis) override
| Add visualization assets for the idler subsystem.
virtual void | RemoveVisualizationAssets () override
| Remove visualization assets for the idler subsystem.
virtual void | LogConstraintViolations () override
| Log current constraint violations.
Public Member Functions inherited from chrono::vehicle::ChIdler
GuidePinType | GetType () const
| Return the type of track shoe consistent with this road wheel.
std::shared_ptr< ChTrackWheel > | GetIdlerWheel () const
| Return the idler wheel subsystem.
std::shared_ptr< ChBody > | GetWheelBody () const
| Return the body of the idler wheel.
double | GetWheelRadius () const
| Get the radius of the idler wheel.
virtual void | SetOutput (bool state) override
| Enable/disable output for this subsystem.
Public Member Functions inherited from chrono::vehicle::ChPart
const std::string & | GetName () const
| Get the name identifier for this subsystem.
void | SetName (const std::string &name)
| Set the name identifier for this subsystem.
bool | IsInitialized () const
| Return flag indicating whether or not the part is fully constructed.
double | GetMass () const
| Get the subsystem mass.
const ChFrame & | GetCOMFrame () const
| Get the current subsystem COM frame (relative to and expressed in the subsystem's reference frame).
const ChMatrix33 & | GetInertia () const
| Get the current subsystem inertia (relative to the subsystem COM frame).
const ChFrame & | GetTransform () const
| Get the current subsystem position relative to the global frame.
void | SetVisualizationType (VisualizationType vis)
| Set the visualization mode for this subsystem.
bool | OutputEnabled () const
| Return the output state for this subsystem.

## Additional Inherited Members
Static Public Member Functions inherited from chrono::vehicle::ChPart
static ChMatrix33 | TransformInertiaMatrix (const ChVector3d &moments, const ChVector3d &products, const ChMatrix33<> &vehicle_rot, const ChMatrix33<> &body_rot)
| Utility function for transforming inertia tensors between centroidal frames.
Protected Types inherited from chrono::vehicle::ChTranslationalIdler
enum | PointId { CARRIER , CARRIER_WHEEL , CARRIER_CHASSIS , TSDA_CARRIER , TSDA_CHASSIS , NUM_POINTS }
| Identifiers for the various hardpoints. More...
Protected Member Functions inherited from chrono::vehicle::ChTranslationalIdler
virtual void | InitializeInertiaProperties () override
| Initialize subsystem inertia properties.
virtual void | UpdateInertiaProperties () override
| Update subsystem inertia properties.
virtual void | ExportComponentList (rapidjson::Document &jsonDocument) const override
| Export this subsystem's component list to the specified JSON object.
virtual void | Output (ChVehicleOutput &database) const override
| Output data for this subsystem's component list to the specified database.
Protected Member Functions inherited from chrono::vehicle::ChIdler
| ChIdler (const std::string &name)
| Construct an idler subsystem with given name.
Protected Member Functions inherited from chrono::vehicle::ChPart
| ChPart (const std::string &name)
| Construct a vehicle subsystem with the specified name.
void | AddMass (double &mass)
| Add this subsystem's mass.
void | AddInertiaProperties (ChVector3d &com, ChMatrix33<> &inertia)
| Add this subsystem's inertia properties.
virtual void | Create (const rapidjson::Document &d)
| Create a vehicle subsystem from JSON data.
void | ExportBodyList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChBody > > bodies) const
| Export the list of bodies to the specified JSON document.
void | ExportShaftList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaft > > shafts) const
| Export the list of shafts to the specified JSON document.
void | ExportJointList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLink > > joints) const
| Export the list of joints to the specified JSON document.
void | ExportCouplesList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaftsCouple > > couples) const
| Export the list of shaft couples to the specified JSON document.
void | ExportMarkerList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChMarker > > markers) const
| Export the list of markers to the specified JSON document.
void | ExportLinSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkTSDA > > springs) const
| Export the list of translational springs to the specified JSON document.
void | ExportRotSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkRSDA > > springs) const
| Export the list of rotational springs to the specified JSON document.
void | ExportBodyLoadList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLoadBodyBody > > loads) const
| Export the list of body-body loads to the specified JSON document.
Static Protected Member Functions inherited from chrono::vehicle::ChPart
static void | RemoveVisualizationAssets (std::shared_ptr< ChPhysicsItem > item)
| Erase all visual shapes from the visual model associated with the specified physics item (if any).
static void | RemoveVisualizationAsset (std::shared_ptr< ChPhysicsItem > item, std::shared_ptr< ChVisualShape > shape)
| Erase the given shape from the visual model associated with the specified physics item (if any).
Protected Attributes inherited from chrono::vehicle::ChTranslationalIdler
std::shared_ptr< ChBody > | m_carrier
| carrier body
std::shared_ptr< ChLinkLockPrismatic > | m_prismatic
| carrier-chassis translational joint
std::shared_ptr< ChLinkTSDA > | m_tensioner
| TSDA tensioner element.
Protected Attributes inherited from chrono::vehicle::ChIdler
GuidePinType | m_type
| type of the track shoe matching this road wheel
ChVector3d | m_rel_loc
| idler subsystem location relative to chassis
std::shared_ptr< ChTrackWheel > | m_idler_wheel
| idler-wheel subsystem
ChTrackAssembly * | m_track
| containing track assembly
Protected Attributes inherited from chrono::vehicle::ChPart
std::string | m_name
| subsystem name
bool | m_initialized
| specifies whether ot not the part is fully constructed
bool | m_output
| specifies whether or not output is generated for this subsystem
std::shared_ptr< ChPart > | m_parent
| parent subsystem (empty if parent is vehicle)
double | m_mass
| subsystem mass
ChMatrix33 | m_inertia
| inertia tensor (relative to subsystem COM)
ChFrame | m_com
| COM frame (relative to subsystem reference frame).
ChFrame | m_xform
| subsystem frame expressed in the global frame

## Member Function Documentation

## ◆ GetCarrierInertia()

virtual const ChVector3d & chrono::vehicle::m113::M113_Idler::GetCarrierInertia | ( |  | ) |
| inlineoverridevirtual

Return the moments of inertia of the carrier body.

Implements chrono::vehicle::ChTranslationalIdler.

## ◆ GetCarrierMass()

virtual double chrono::vehicle::m113::M113_Idler::GetCarrierMass | ( |  | ) | const
| inlineoverridevirtual

Return the mass of the carrier body.

Implements chrono::vehicle::ChTranslationalIdler.

## ◆ GetCarrierVisRadius()

virtual double chrono::vehicle::m113::M113_Idler::GetCarrierVisRadius | ( |  | ) | const
| inlineoverridevirtual

Return a visualization radius for the carrier body.

Implements chrono::vehicle::ChTranslationalIdler.

## ◆ GetLocation()

const ChVector3d chrono::vehicle::m113::M113_Idler::GetLocation | ( | PointId | which | ) |
| overridevirtual

Return the location of the specified hardpoint.

The returned location must be expressed in the idler subsystem reference frame.

Implements chrono::vehicle::ChTranslationalIdler.

## ◆ GetPrismaticPitchAngle()

virtual double chrono::vehicle::m113::M113_Idler::GetPrismaticPitchAngle | ( |  | ) | const
| inlineoverridevirtual

Return the pitch angle of the prismatic joint.

Implements chrono::vehicle::ChTranslationalIdler.

## ◆ GetTensionerForceCallback()

virtual std::shared_ptr< ChLinkTSDA::ForceFunctor > chrono::vehicle::m113::M113_Idler::GetTensionerForceCallback | ( |  | ) | const
| inlineoverridevirtual

Return the functor object for spring force.

Implements chrono::vehicle::ChTranslationalIdler.

## ◆ GetTensionerFreeLength()

virtual double chrono::vehicle::m113::M113_Idler::GetTensionerFreeLength | ( |  | ) | const
| inlineoverridevirtual

Return the free length for the tensioner spring.

Implements chrono::vehicle::ChTranslationalIdler.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_models/vehicle/m113/M113_Idler.h
- D:/W/B/src/chrono-9.0.1/src/chrono_models/vehicle/m113/M113_Idler.cpp